;<ff
Window frmMain, 3, 0, 'TForm', 'Parent (+)', $16080000, $10, 0, 0, 0, 674, 375, MainFormWinProc;
Window NONE, 1, 0, 'TForm', 'Child 1 (+)', $50800000, $10010, 0, 16, 16, 368, 320, ChildWinProc;
Window NONE, 1, 0, 'BUTTON', 'Child 2 (+)', $50000000, $10, 0, 56, 40, 216, 145, ChildWinProc;
Window NONE, 2, 0, 'BUTTON', 'Child 3 (+)', $50000000, $10, 0, 24, 24, 168, 25, ChildWinProc;
Window NONE, 0, 0, 'STATIC', 'Child 1 (+)', $50000000, $0, 0, 16, 5, 72, 24, 0;
Window NONE, 0, 0, 'BUTTON', 'Disabled (-)', $58000000, $10, 0, 248, 272, 96, 33, 0;
Window NONE, 0, 0, 'STATIC', 'Static (+)', $50800201, $10, 0, 24, 264, 96, 40, ChildWinProc;
Window NONE, 2, 0, 'BUTTON', 'Not a target (-)', $50000000, $0, 0, 128, 208, 216, 33, 0;
Window NONE, 0, 0, 'STATIC', 'Drop some file on the different controls and look here. The valid targets are marked with (+) the invalid with (-)', $50800000, $0, 123, 400, 24, 256, 69, 0;
Window NONE, 2, 0, 'BUTTON', 'WindowFromPoint drag from here to the test control', $50002300, $0, 0, 528, 256, 128, 72, WindowFromPointTest;
;ff>

;-----------------------------------------------------------------------
; Window procedure for the form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
proc MainFormWinProc, .hwnd, .wmsg, .wparam, .lparam
begin

        dispatch [.wmsg]

.ondefault:
        stc
        return

oncase WM_CLOSE

        invoke  PostQuitMessage, 0
        clc
        xor     eax, eax
        return

oncase WM_DROPFILES

        stdcall OnDropFiles, [.hwnd]
        clc
        xor     eax, eax
        return

        enddispatch

endp





proc ChildWinProc, .hwnd, .wmsg, .wparam, .lparam
begin
        cmp     [.wmsg], WM_DROPFILES
        je      .drop_files

        stc
        return


.drop_files:
        stdcall OnDropFiles, [.hwnd]
        xor     eax, eax
        clc
        return
endp



proc OnDropFiles, .hwnd
.buffer rb 256
begin
        pushad

        stdcall StrDupMem, "Files dropped on: "
        mov     esi, eax

        lea     ebx, [.buffer]
        invoke  GetWindowTextA, [.hwnd], ebx, 256
        test    eax, eax
        jz      .skip

        stdcall StrCatMem, esi, ebx, eax

.skip:
        stdcall StrPtr, esi
        invoke  SendDlgItemMessageA, [hMainForm], 123, WM_SETTEXT, 0, eax

        stdcall StrDel, esi

        popad
        return
endp



proc WindowFromPointTest, .hwnd, .wmsg, .wparam, .lparam
begin
        dispatch [.wmsg]

.ondefault:
        stc
        return

oncase WM_LBUTTONDOWN
        invoke  SetCapture, [.hwnd]

        invoke  LoadCursorW, 0, IDC_CROSS
        invoke  SetCursor, eax

        xor     eax, eax
        clc
        return

oncase WM_LBUTTONUP
locals
  .point POINT
  .buffer rb 256
endl

        pushad

        lea     eax, [.point]
        invoke  GetCursorPos, eax
        invoke  WindowFromPoint, [.point.x], [.point.y]
        test    eax, eax
        jz      .finish

        mov     edi, eax

        stdcall StrDupMem, "WindowFromPoint: "
        mov     esi, eax

        lea     ebx, [.buffer]
        invoke  GetWindowTextA, edi, ebx, 256
        test    eax, eax
        jz      .freestr

        stdcall StrCatMem, esi, ebx, eax

        stdcall StrPtr, esi
        invoke  SendDlgItemMessageA, [hMainForm], 123, WM_SETTEXT, 0, eax

.freestr:
        stdcall StrDel, esi

.finish:
        invoke  LoadCursorW, 0, IDC_ARROW
        invoke  SetCursor, eax
        invoke  ReleaseCapture

        popad
        xor     eax, eax
        clc
        return

        enddispatch
endp
